From 675bb26d5422540a39d43d121bbaffe965d3a749 Mon Sep 17 00:00:00 2001
From: Evan <18405113+evbauer@users.noreply.github.com>
Date: Tue, 16 Mar 2021 15:11:23 -0400
Subject: [PATCH] PC EOS back to 12778

---
 eos/private/eospc_eval.f90 |  131 +-
 eos/private/pc_eos.f90     | 2351 ++++++++++++++----------------------
 2 files changed, 928 insertions(+), 1554 deletions(-)

diff --git a/eos/private/eospc_eval.f90 b/eos/private/eospc_eval.f90
index 93d46a1a..a0d4b107 100644
--- a/eos/private/eospc_eval.f90
+++ b/eos/private/eospc_eval.f90
@@ -61,11 +61,11 @@
          logRho_hi = rq% logRho1_PC_limit ! okay for pure PC for logRho > this
          
          if (rq% PC_use_Gamma_limit_instead_of_T) then
-            !gamma_e = (qe**2)*(four_thirds_pi*avo*Rho*zbar/abar)**one_third/(kerg*T)
+            !gamma_e = (qe**2)*((4.0d0/3.0d0)*pi*avo*Rho*zbar/abar)**one_third/(kerg*T)
             !logGe = logGe0 + logRho/3 - logT
-            ! where Ge0 = (qe**2)*(four_thirds_pi*avo*zbar/abar)**one_third/kerg
+            ! where Ge0 = (qe**2)*((4.0d0/3.0d0)*pi*avo*zbar/abar)**one_third/kerg
             logGe0 = log10( & 
-                 qe*qe*pow(four_thirds_pi*avo*zbar/abar, one_third)/kerg)
+                 qe*qe*pow((4.0d0/3.0d0)*pi*avo*zbar/abar,(1d0/3d0))/kerg)
             logGe = logGe0 + logRho/3 - logT
             logGe_lo = rq% log_Gamma_e_all_HELM ! HELM for logGe <= this
             logGe_hi = rq% log_Gamma_e_all_PC ! PC for logGe >= this
@@ -133,10 +133,10 @@
             res, d_dlnd, d_dlnT, d_dxa, ierr)
          skip = .false.
 
-         ! zero latent heat information
-         res(i_latent_ddlnT:i_latent_ddlnRho) = 0d0
-         d_dlnT(i_latent_ddlnT:i_latent_ddlnRho) = 0d0
-         d_dlnd(i_latent_ddlnT:i_latent_ddlnRho) = 0d0
+         ! zero phase information
+         res(i_phase:i_latent_ddlnRho) = 0d0
+         d_dlnT(i_phase:i_latent_ddlnRho) = 0d0
+         d_dlnd(i_phase:i_latent_ddlnRho) = 0d0
 
          ! zero all components
          res(i_frac:i_frac+num_eos_frac_results-1) = 0.0
@@ -168,13 +168,21 @@
          real(dp), intent(inout) :: d_dxa(:,:) ! (nv, species)
          integer, intent(out) :: ierr
          
+         real(dp) :: Ni, N, lnT, lnRho, dlnT, dlnRho, Rho2, T3
          real(dp) :: start_crystal, full_crystal
          real(dp), dimension(species) :: AY, AZion, ACMI
          integer :: i, j
+         real(dp), parameter :: lnT_frac = 1d-7, lnRho_frac = 1d-7
+         real(dp), dimension(nv) :: &
+            res2, d_dlnRho_c_T2, d_dlnRho_c_Rho2, &
+            res3, d_dlnRho_c_T3, d_dlnRho_c_Rho3
          
          include 'formats'
          
          ierr = 0
+
+         Ni = rho/(abar*amu)
+         N = Ni/rho
          AZion(1:species) = chem_isos% Z(chem_id(1:species))
          ACMI(1:species) = chem_isos% W(chem_id(1:species)) ! this really is atomic weight.
          do j=1,species
@@ -188,8 +196,13 @@
          start_crystal = rq% PC_Gamma_start_crystal
          full_crystal = rq% PC_Gamma_full_crystal
 
-
-         call do1(.false.,Rho,T,start_crystal,full_crystal,res,d_dlnT_c_Rho,d_dlnRho_c_T,ierr)
+         lnT = logT*ln10
+         lnRho = logRho*ln10
+         
+         dlnT = lnT*lnT_frac
+         dlnRho = lnRho*lnRho_frac
+         
+         call do1(.false.,Rho,T,start_crystal,full_crystal,res,ierr)
          if (ierr /= 0) return
 
          ! composition derivatives not provided
@@ -201,21 +214,33 @@
             stop 'Get_PC_Results'
          end if
 
+         Rho2 = exp(lnRho+dlnRho)
+         call do1(.false.,Rho2,T,start_crystal,full_crystal,res2,ierr)
+         if (ierr /= 0) return
+         
+         T3 = exp(lnT+dlnT)
+         call do1(.false.,Rho,T3,start_crystal,full_crystal,res3,ierr)
+         if (ierr /= 0) return
+         
+         do j=1,nv
+            d_dlnRho_c_T(j) = (res2(j)-res(j))/dlnRho
+            d_dlnT_c_Rho(j) = (res3(j)-res(j))/dlnT
+         end do
+
          contains
          
-         subroutine do1(show,RHO_real,T_real,start_crystal,full_crystal,res,d_dlnT_c_Rho,d_dlnRho_c_T,ierr)
+         subroutine do1(show,RHO_real,T_real,start_crystal,full_crystal,res,ierr)
             logical, intent(in) :: show
             real(dp), intent(in) :: start_crystal, full_crystal
             real(dp), intent(in) :: RHO_real, T_real
-            real(dp), intent(out) :: res(:), d_dlnT_c_Rho(:), d_dlnRho_c_T(:) ! (nv)
+            real(dp), intent(out) :: res(:) ! (nv)
             integer, intent(out) :: ierr
 
             integer :: j, LIQSOL
-            type(auto_diff_real_2var_order1) :: dsp, dse, dpe, &
+            real(dp) :: dsp, dse, dpe, &
                DENS,GAMI,CHI,TPT,GAMImean,TEMP, &
                PnkT,UNkT,SNk,CVNkt,CV,CHIR,CHIT,Tnk,P,Cp,gamma1,gamma3,grad_ad, N, &
                Prad,Pgas,PRADnkT,dE_dRho,dS_dT,dS_dRho,mu,lnfree_e, lnPgas, lnE, lnS, RHO, T
-            type(auto_diff_real_2var_order1) :: phase
             real(dp) :: Zmean,CMImean,Z2mean
             real(dp), parameter :: UN_T6=0.3157746d0
 
@@ -224,10 +249,8 @@
             ierr = 0
             
             T = T_real
-            T%d1val1 = 1d0
 
             RHO = RHO_real
-            RHO%d1val2 = 1d0
          
             TEMP=T*1d-6/UN_T6 ! T [au]
 
@@ -247,15 +270,6 @@
                start_crystal,full_crystal,PRADnkT, &
                DENS,Zmean,CMImean,Z2mean,GAMImean,CHI,TPT,LIQSOL, &
                PnkT,UNkT,SNk,CVNkt,CHIR,CHIT,ierr)
-
-            ! calculate phase information
-            if (GAMImean.lt.start_crystal) then ! liquid
-               phase = 0d0
-            else if (GAMImean.gt.full_crystal) then ! solid
-               phase = 1d0
-            else ! blend of liquid and solid
-               phase = (GAMImean - start_crystal)/(full_crystal - start_crystal) ! 1 for solid, 0 for liquid
-            end if
             
             if (ierr /= 0) then
                return
@@ -313,59 +327,22 @@
             lnS = safe_log(SNk*N*kerg)
 
 
-            res(i_lnPgas) = lnPgas % val
-            res(i_lnE) = lnE % val
-            res(i_lnS) = lnS % val
-            res(i_grad_ad) = grad_ad % val
-            res(i_chiRho) = CHIR % val
-            res(i_chiT) = CHIT % val
-            res(i_Cp) = Cp % val
-            res(i_Cv) = CV % val
-            res(i_dE_dRho) = dE_dRho % val
-            res(i_dS_dT) = dS_dT % val
-            res(i_dS_dRho) = dS_dRho % val
-            res(i_mu) = mu % val
-            res(i_lnfree_e) = lnfree_e % val
-            res(i_gamma1) = gamma1 % val
-            res(i_gamma3) = gamma3 % val
-            res(i_eta) = CHI % val
-            res(i_phase) = phase % val
-
-            d_dlnT_c_Rho(i_lnPgas) = lnPgas % d1val1 * T % val
-            d_dlnT_c_Rho(i_lnE) = lnE % d1val1 * T % val
-            d_dlnT_c_Rho(i_lnS) = lnS % d1val1 * T % val
-            d_dlnT_c_Rho(i_grad_ad) = grad_ad % d1val1 * T % val
-            d_dlnT_c_Rho(i_chiRho) = CHIR % d1val1 * T % val
-            d_dlnT_c_Rho(i_chiT) = CHIT % d1val1 * T % val
-            d_dlnT_c_Rho(i_Cp) = Cp % d1val1 * T % val
-            d_dlnT_c_Rho(i_Cv) = CV % d1val1 * T % val
-            d_dlnT_c_Rho(i_dE_dRho) = dE_dRho % d1val1 * T % val
-            d_dlnT_c_Rho(i_dS_dT) = dS_dT % d1val1 * T % val
-            d_dlnT_c_Rho(i_dS_dRho) = dS_dRho % d1val1 * T % val
-            d_dlnT_c_Rho(i_mu) = mu % d1val1 * T % val
-            d_dlnT_c_Rho(i_lnfree_e) = lnfree_e % d1val1 * T % val
-            d_dlnT_c_Rho(i_gamma1) = gamma1 % d1val1 * T % val
-            d_dlnT_c_Rho(i_gamma3) = gamma3 % d1val1 * T % val
-            d_dlnT_c_Rho(i_eta) = CHI % d1val1 * T % val
-            d_dlnT_c_Rho(i_phase) = phase % d1val1 * T % val
-
-            d_dlnRho_c_T(i_lnPgas) = lnPgas % d1val2 * RHO % val
-            d_dlnRho_c_T(i_lnE) = lnE % d1val2 * RHO % val
-            d_dlnRho_c_T(i_lnS) = lnS % d1val2 * RHO % val
-            d_dlnRho_c_T(i_grad_ad) = grad_ad % d1val2 * RHO % val
-            d_dlnRho_c_T(i_chiRho) = CHIR % d1val2 * RHO % val
-            d_dlnRho_c_T(i_chiT) = CHIT % d1val2 * RHO % val
-            d_dlnRho_c_T(i_Cp) = Cp % d1val2 * RHO % val
-            d_dlnRho_c_T(i_Cv) = CV % d1val2 * RHO % val
-            d_dlnRho_c_T(i_dE_dRho) = dE_dRho % d1val2 * RHO % val
-            d_dlnRho_c_T(i_dS_dT) = dS_dT % d1val2 * RHO % val
-            d_dlnRho_c_T(i_dS_dRho) = dS_dRho % d1val2 * RHO % val
-            d_dlnRho_c_T(i_mu) = mu % d1val2 * RHO % val
-            d_dlnRho_c_T(i_lnfree_e) = lnfree_e % d1val2 * RHO % val
-            d_dlnRho_c_T(i_gamma1) = gamma1 % d1val2 * RHO % val
-            d_dlnRho_c_T(i_gamma3) = gamma3 % d1val2 * RHO % val
-            d_dlnRho_c_T(i_eta) = CHI % d1val2 * RHO % val
-            d_dlnRho_c_T(i_phase) = phase % d1val2 * RHO % val
+            res(i_lnPgas) = lnPgas
+            res(i_lnE) = lnE
+            res(i_lnS) = lnS
+            res(i_grad_ad) = grad_ad
+            res(i_chiRho) = CHIR
+            res(i_chiT) = CHIT
+            res(i_Cp) = Cp
+            res(i_Cv) = CV
+            res(i_dE_dRho) = dE_dRho
+            res(i_dS_dT) = dS_dT
+            res(i_dS_dRho) = dS_dRho
+            res(i_mu) = mu
+            res(i_lnfree_e) = lnfree_e
+            res(i_gamma1) = gamma1
+            res(i_gamma3) = gamma3
+            res(i_eta) = CHI
 
          end subroutine do1
      
